/**
 * oclazyload - Load modules on demand (lazy load) with angularJS
 * @version v1.0.9
 * @link https://github.com/ocombe/ocLazyLoad
 * @license MIT
 * @author Olivier Combe <olivier.combe@gmail.com>
 */
!function(e,n){"use strict";var o=["ng","oc.lazyLoad"],r={},t=[],i=[],a=[],s=[],u=e.noop,c={},d=[];e.module("oc.lazyLoad",["ng"]).provider("$ocLazyLoad",["$controllerProvider","$provide","$compileProvider","$filterProvider","$injector","$animateProvider",function(l,g,p,m,v,y){var L={},$={$controllerProvider:l,$compileProvider:p,$filterProvider:m,$provide:g,$injector:v,$animateProvider:y},_=!1,j=!1,E=[],x={};E.push=function(e){-1===this.indexOf(e)&&Array.prototype.push.apply(this,arguments)},this.config=function(n){e.isDefined(n.modules)&&(e.isArray(n.modules)?e.forEach(n.modules,(function(e){L[e.name]=e})):L[n.modules.name]=n.modules),e.isDefined(n.debug)&&(_=n.debug),e.isDefined(n.events)&&(j=n.events)},this._init=function _init(r){if(0===i.length){var t=[r],a=["ng:app","ng-app","x-ng-app","data-ng-app"],u=/\sng[:\-]app(:\s*([\w\d_]+);?)?\s/,c=function append(e){return e&&t.push(e)};e.forEach(a,(function(n){a[n]=!0,c(document.getElementById(n)),n=n.replace(":","\\:"),void 0!==r[0]&&r[0].querySelectorAll&&(e.forEach(r[0].querySelectorAll("."+n),c),e.forEach(r[0].querySelectorAll("."+n+"\\:"),c),e.forEach(r[0].querySelectorAll("["+n+"]"),c))})),e.forEach(t,(function(n){if(0===i.length){var o=" "+r.className+" ",t=u.exec(o);t?i.push((t[2]||"").replace(/\s+/g,",")):e.forEach(n.attributes,(function(e){0===i.length&&a[e.name]&&i.push(e.value)}))}}))}0!==i.length||(n.jasmine||n.mocha)&&e.isDefined(e.mock)||console.error("No module found during bootstrap, unable to init ocLazyLoad. You should always use the ng-app directive or angular.boostrap when you use ocLazyLoad.");e.forEach(i,(function(n){!function addReg(n){if(-1===o.indexOf(n)){o.push(n);var r=e.module(n);_invokeQueue(null,r._invokeQueue,n),_invokeQueue(null,r._configBlocks,n),e.forEach(r.requires,addReg)}}(n)})),i=[],s.pop()};var w=function stringify(n){try{return JSON.stringify(n)}catch(r){var o=[];return JSON.stringify(n,(function(n,r){if(e.isObject(r)&&null!==r){if(-1!==o.indexOf(r))return;o.push(r)}return r}))}},O=function hashCode(e){var n,o,r=0;if(0==e.length)return r;for(n=0,o=e.length;n<o;n++)r=(r<<5)-r+e.charCodeAt(n),r|=0;return r};function _register(n,r,t){if(r){var i,s,l,f=[];for(i=r.length-1;i>=0;i--)if(s=r[i],e.isString(s)||(s=getModuleName(s)),s&&-1===d.indexOf(s)&&(!L[s]||-1!==a.indexOf(s))){var g=-1===o.indexOf(s);if(l=h(s),g&&(o.push(s),_register(n,l.requires,t)),l._runBlocks.length>0)for(c[s]=[];l._runBlocks.length>0;)c[s].push(l._runBlocks.shift());e.isDefined(c[s])&&(g||t.rerun)&&(f=f.concat(c[s])),_invokeQueue(n,l._invokeQueue,s,t.reconfig),_invokeQueue(n,l._configBlocks,s,t.reconfig),u(g?"ocLazyLoad.moduleLoaded":"ocLazyLoad.moduleReloaded",s),r.pop(),d.push(s)}var p=n.getInstanceInjector();e.forEach(f,(function(e){p.invoke(e)}))}}function _registerInvokeList(n,o){var t=n[2][0],i=n[1],a=!1;e.isUndefined(r[o])&&(r[o]={}),e.isUndefined(r[o][i])&&(r[o][i]={});var s=function onInvoke(n,t){r[o][i].hasOwnProperty(n)||(r[o][i][n]=[]),function checkHashes(n,o){var r,t=!0;o.length&&(r=signature(n),e.forEach(o,(function(e){t=t&&signature(e)!==r})));return t}(t,r[o][i][n])&&(a=!0,r[o][i][n].push(t),u("ocLazyLoad.componentLoaded",[o,i,n]))};function signature(n){return e.isArray(n)?O(n.toString()):e.isObject(n)?O(w(n)):e.isDefined(n)&&null!==n?O(n.toString()):n}if(e.isString(t))s(t,n[2][1]);else{if(!e.isObject(t))return!1;e.forEach(t,(function(n,o){e.isString(n)?s(n,t[1]):s(o,n)}))}return a}function _invokeQueue(n,o,r,i){var a,s,u,c;if(o)for(a=0,s=o.length;a<s;a++)if(u=o[a],e.isArray(u)){if(null!==n){if(!n.hasOwnProperty(u[0]))throw new Error("unsupported provider "+u[0]);c=n[u[0]]}var d=_registerInvokeList(u,r);if("invoke"!==u[1])d&&e.isDefined(c)&&c[u[1]].apply(c,u[2]);else{var l=function callInvoke(n){var o=t.indexOf(r+"-"+n);(-1===o||i)&&(-1===o&&t.push(r+"-"+n),e.isDefined(c)&&c[u[1]].apply(c,u[2]))};if(e.isFunction(u[2][0]))l(u[2][0]);else if(e.isArray(u[2][0]))for(var f=0,h=u[2][0].length;f<h;f++)e.isFunction(u[2][0][f])&&l(u[2][0][f])}}}function getModuleName(n){var o=null;return e.isString(n)?o=n:e.isObject(n)&&n.hasOwnProperty("name")&&e.isString(n.name)&&(o=n.name),o}function moduleExists(n){if(!e.isString(n))return!1;try{return h(n)}catch(e){if(/No module/.test(e)||e.message.indexOf("$injector:nomod")>-1)return!1}}this.$get=["$log","$rootElement","$rootScope","$cacheFactory","$q",function(n,t,a,c,l){var g,p=c("ocLazyLoad");function reject(e){var o=l.defer();return n.error(e.message),o.reject(e),o.promise}return _||((n={}).error=e.noop,n.warn=e.noop,n.info=e.noop),$.getInstanceInjector=function(){return g||(g=t.data("$injector")||e.injector())},{_broadcast:u=function broadcast(e,o){j&&a.$broadcast(e,o),_&&n.info(e,o)},_$log:n,_getFilesCache:function getFilesCache(){return p},toggleWatch:function toggleWatch(e){e?s.push(!0):s.pop()},getModuleConfig:function getModuleConfig(n){if(!e.isString(n))throw new Error("You need to give the name of the module to get");return L[n]?e.copy(L[n]):null},setModuleConfig:function setModuleConfig(n){if(!e.isObject(n))throw new Error("You need to give the module config object to set");return L[n.name]=n,n},getModules:function getModules(){return o},isLoaded:function isLoaded(n){var r=function moduleLoaded(e){var n=o.indexOf(e)>-1;return n||(n=!!moduleExists(e)),n};if(e.isString(n)&&(n=[n]),e.isArray(n)){var t,i;for(t=0,i=n.length;t<i;t++)if(!r(n[t]))return!1;return!0}throw new Error("You need to define the module(s) name(s)")},_getModuleName:getModuleName,_getModule:function getModule(e){try{return h(e)}catch(n){throw(/No module/.test(n)||n.message.indexOf("$injector:nomod")>-1)&&(n.message='The module "'+w(e)+'" that you are trying to load does not exist. '+n.message),n}},moduleExists:moduleExists,_loadDependencies:function _loadDependencies(n,o){var r,t,i,a=[],s=this;if(null===(n=s._getModuleName(n)))return l.when();try{r=s._getModule(n)}catch(e){return reject(e)}return t=s.getRequires(r),e.forEach(t,(function(r){if(e.isString(r)){var t=s.getModuleConfig(r);if(null===t)return void E.push(r);r=t,t.name=void 0}if(s.moduleExists(r.name))return 0!==(i=r.files.filter((function(e){return s.getModuleConfig(r.name).files.indexOf(e)<0}))).length&&s._$log.warn('Module "',n,'" attempted to redefine configuration for dependency. "',r.name,'"\n Additional Files Loaded:',i),e.isDefined(s.filesLoader)?void a.push(s.filesLoader(r,o).then((function(){return s._loadDependencies(r)}))):reject(new Error("Error: New dependencies need to be loaded from external files ("+r.files+"), but no loader has been defined."));if(e.isArray(r)){var u=[];e.forEach(r,(function(e){var n=s.getModuleConfig(e);null===n?u.push(e):n.files&&(u=u.concat(n.files))})),u.length>0&&(r={files:u})}else e.isObject(r)&&r.hasOwnProperty("name")&&r.name&&(s.setModuleConfig(r),E.push(r.name));if(e.isDefined(r.files)&&0!==r.files.length){if(!e.isDefined(s.filesLoader))return reject(new Error('Error: the module "'+r.name+'" is defined in external files ('+r.files+"), but no loader has been defined."));a.push(s.filesLoader(r,o).then((function(){return s._loadDependencies(r)})))}})),l.all(a)},inject:function inject(n){var o=arguments.length<=1||void 0===arguments[1]?{}:arguments[1],r=!(arguments.length<=2||void 0===arguments[2])&&arguments[2],t=this,a=l.defer();if(e.isDefined(n)&&null!==n){if(e.isArray(n)){var s=[];return e.forEach(n,(function(e){s.push(t.inject(e,o,r))})),l.all(s)}t._addToLoadList(t._getModuleName(n),!0,r)}if(i.length>0){var u=i.slice(),c=function loadNext(e){E.push(e),x[e]=a.promise,t._loadDependencies(e,o).then((function success(){try{d=[],_register($,E,o)}catch(e){return t._$log.error(e.message),void a.reject(e)}i.length>0?loadNext(i.shift()):a.resolve(u)}),(function error(e){a.reject(e)}))};c(i.shift())}else{if(o&&o.name&&x[o.name])return x[o.name];a.resolve()}return a.promise},getRequires:function getRequires(n){var r=[];return e.forEach(n.requires,(function(e){-1===o.indexOf(e)&&r.push(e)})),r},_invokeQueue:_invokeQueue,_registerInvokeList:_registerInvokeList,_register:_register,_addToLoadList:f,_unregister:function _unregister(n){e.isDefined(n)&&e.isArray(n)&&e.forEach(n,(function(e){r[e]=void 0}))}}}],this._init(e.element(n.document))}]);var l=e.bootstrap;e.bootstrap=function(n,o,r){return e.forEach(o.slice(),(function(e){f(e,!0,!0)})),l(n,o,r)};var f=function _addToLoadList(n,o,r){(s.length>0||o)&&e.isString(n)&&-1===i.indexOf(n)&&(i.push(n),r&&a.push(n))},h=e.module;e.module=function(e,n,o){return f(e,!1,!0),h(e,n,o)},"undefined"!=typeof module&&"undefined"!=typeof exports&&module.exports===exports&&(module.exports="oc.lazyLoad")}(angular,window),function(e){"use strict";e.module("oc.lazyLoad").directive("ocLazyLoad",["$ocLazyLoad","$compile","$animate","$parse","$timeout",function(n,o,r,t,i){return{restrict:"A",terminal:!0,priority:1e3,compile:function compile(i,a){var s=i[0].innerHTML;return i.html(""),function(i,a,u){var c=t(u.ocLazyLoad);i.$watch((function(){return c(i)||u.ocLazyLoad}),(function(t){e.isDefined(t)&&n.load(t).then((function(){r.enter(s,a),o(a.contents())(i)}))}),!0)}}}}])}(angular),function(e){"use strict";e.module("oc.lazyLoad").config(["$provide",function(n){n.decorator("$ocLazyLoad",["$delegate","$q","$window","$interval",function(n,o,r,t){var i=!1,a=r.document.getElementsByTagName("head")[0]||r.document.getElementsByTagName("body")[0];return n.buildElement=function buildElement(s,u,c){var d,l,f=o.defer(),h=n._getFilesCache(),g=function cacheBuster(e){var n=(new Date).getTime();return e.indexOf("?")>=0?"&"===e.substring(0,e.length-1)?e+"_dc="+n:e+"&_dc="+n:e+"?_dc="+n};switch(e.isUndefined(h.get(u))&&h.put(u,f.promise),s){case"css":(d=r.document.createElement("link")).type="text/css",d.rel="stylesheet",d.href=!1===c.cache?g(u):u;break;case"js":(d=r.document.createElement("script")).src=!1===c.cache?g(u):u,c.charset&&(d.charset=c.charset);break;default:h.remove(u),f.reject(new Error('Requested type "'+s+'" is not known. Could not inject "'+u+'"'))}d.onload=d.onreadystatechange=function(e){d.readyState&&!/^c|loade/.test(d.readyState)||l||(d.onload=d.onreadystatechange=null,l=1,n._broadcast("ocLazyLoad.fileLoaded",u),f.resolve(d))},d.onerror=function(){h.remove(u),f.reject(new Error("Unable to load "+u))},d.async=c.serie?0:1;var p=a.lastChild;if(c.insertBefore){var m=e.element(e.isDefined(window.jQuery)?c.insertBefore:document.querySelector(c.insertBefore));m&&m.length>0&&(p=m[0])}if(p.parentNode.insertBefore(d,p),"css"==s){var v=r.navigator.userAgent.toLowerCase();if(/iP(hone|od|ad)/.test(r.navigator.platform)){var y=r.navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/),L=parseFloat([parseInt(y[1],10),parseInt(y[2],10),parseInt(y[3]||0,10)].join("."));i=L<6}else if(v.indexOf("android")>-1){var $=parseFloat(v.slice(v.indexOf("android")+8));i=$<4.4}else if(v.indexOf("safari")>-1){var _=v.match(/version\/([\.\d]+)/i);i=_&&_[1]&&parseFloat(_[1])<6}if(i)var j=1e3,E=t((function(){try{d.sheet.cssRules,t.cancel(E),d.onload()}catch(e){--j<=0&&d.onerror()}}),20)}return f.promise},n}])}])}(angular),function(e){"use strict";e.module("oc.lazyLoad").config(["$provide",function(n){n.decorator("$ocLazyLoad",["$delegate","$q",function(n,o){return n.filesLoader=function filesLoader(r){var t=arguments.length<=1||void 0===arguments[1]?{}:arguments[1],i=[],a=[],s=[],u=[],c=null,d=n._getFilesCache();n.toggleWatch(!0),e.extend(t,r);var l=function pushFile(o){var r,l=null;if(e.isObject(o)&&(l=o.type,o=o.path),c=d.get(o),e.isUndefined(c)||!1===t.cache){if(null!==(r=/^(css|less|html|htm|js)?(?=!)/.exec(o))&&(l=r[1],o=o.substr(r[1].length+1,o.length)),!l)if(null!==(r=/[.](css|less|html|htm|js)?((\?|#).*)?$/.exec(o)))l=r[1];else{if(n.jsLoader.hasOwnProperty("ocLazyLoadLoader")||!n.jsLoader.hasOwnProperty("requirejs"))return void n._$log.error("File type could not be determined. "+o);l="js"}"css"!==l&&"less"!==l||-1!==i.indexOf(o)?"html"!==l&&"htm"!==l||-1!==a.indexOf(o)?"js"===l||-1===s.indexOf(o)?s.push(o):n._$log.error("File type is not valid. "+o):a.push(o):i.push(o)}else c&&u.push(c)};if(t.serie?l(t.files.shift()):e.forEach(t.files,(function(e){l(e)})),i.length>0){var f=o.defer();n.cssLoader(i,(function(o){e.isDefined(o)&&n.cssLoader.hasOwnProperty("ocLazyLoadLoader")?(n._$log.error(o),f.reject(o)):f.resolve()}),t),u.push(f.promise)}if(a.length>0){var h=o.defer();n.templatesLoader(a,(function(o){e.isDefined(o)&&n.templatesLoader.hasOwnProperty("ocLazyLoadLoader")?(n._$log.error(o),h.reject(o)):h.resolve()}),t),u.push(h.promise)}if(s.length>0){var g=o.defer();n.jsLoader(s,(function(o){e.isDefined(o)&&(n.jsLoader.hasOwnProperty("ocLazyLoadLoader")||n.jsLoader.hasOwnProperty("requirejs"))?(n._$log.error(o),g.reject(o)):g.resolve()}),t),u.push(g.promise)}if(0===u.length){var p=o.defer(),m="Error: no file to load has been found, if you're trying to load an existing module you should use the 'inject' method instead of 'load'.";return n._$log.error(m),p.reject(m),p.promise}return t.serie&&t.files.length>0?o.all(u).then((function(){return n.filesLoader(r,t)})):o.all(u).finally((function(e){return n.toggleWatch(!1),e}))},n.load=function(r){var t,i=arguments.length<=1||void 0===arguments[1]?{}:arguments[1],a=this,s=null,u=[],c=o.defer(),d=e.copy(r),l=e.copy(i);if(e.isArray(d))return e.forEach(d,(function(e){u.push(a.load(e,l))})),o.all(u).then((function(e){c.resolve(e)}),(function(e){c.reject(e)})),c.promise;if(e.isString(d)?(s=a.getModuleConfig(d))||(s={files:[d]}):e.isObject(d)&&(s=e.isDefined(d.path)&&e.isDefined(d.type)?{files:[d]}:a.setModuleConfig(d)),null===s){var f=a._getModuleName(d);return t='Module "'+(f||"unknown")+'" is not configured, cannot load.',n._$log.error(t),c.reject(new Error(t)),c.promise}e.isDefined(s.template)&&(e.isUndefined(s.files)&&(s.files=[]),e.isString(s.template)?s.files.push(s.template):e.isArray(s.template)&&s.files.concat(s.template));var h=e.extend({},l,s);return e.isUndefined(s.files)&&e.isDefined(s.name)&&n.moduleExists(s.name)?n.inject(s.name,h,!0):(n.filesLoader(s,h).then((function(){n.inject(null,h).then((function(e){c.resolve(e)}),(function(e){c.reject(e)}))}),(function(e){c.reject(e)})),c.promise)},n}])}])}(angular),function(e){"use strict";e.module("oc.lazyLoad").config(["$provide",function(n){n.decorator("$ocLazyLoad",["$delegate","$q",function(n,o){return n.cssLoader=function(r,t,i){var a=[];e.forEach(r,(function(e){a.push(n.buildElement("css",e,i))})),o.all(a).then((function(){t()}),(function(e){t(e)}))},n.cssLoader.ocLazyLoadLoader=!0,n}])}])}(angular),function(e){"use strict";e.module("oc.lazyLoad").config(["$provide",function(n){n.decorator("$ocLazyLoad",["$delegate","$q",function(n,o){return n.jsLoader=function(r,t,i){var a=[];e.forEach(r,(function(e){a.push(n.buildElement("js",e,i))})),o.all(a).then((function(){t()}),(function(e){t(e)}))},n.jsLoader.ocLazyLoadLoader=!0,n}])}])}(angular),function(e){"use strict";e.module("oc.lazyLoad").config(["$provide",function(n){n.decorator("$ocLazyLoad",["$delegate","$templateCache","$q","$http",function(n,o,r,t){return n.templatesLoader=function(i,a,s){var u=[],c=n._getFilesCache();return e.forEach(i,(function(n){var i=r.defer();u.push(i.promise),t.get(n,s).success((function(r){e.isString(r)&&r.length>0&&e.forEach(e.element(r),(function(e){"SCRIPT"===e.nodeName&&"text/ng-template"===e.type&&o.put(e.id,e.innerHTML)})),e.isUndefined(c.get(n))&&c.put(n,!0),i.resolve()})).error((function(e){i.reject(new Error('Unable to load template file "'+n+'": '+e))}))})),r.all(u).then((function(){a()}),(function(e){a(e)}))},n.templatesLoader.ocLazyLoadLoader=!0,n}])}])}(angular),Array.prototype.indexOf||(Array.prototype.indexOf=function(e,n){var o;if(null==this)throw new TypeError('"this" is null or not defined');var r=Object(this),t=r.length>>>0;if(0===t)return-1;var i=+n||0;if(Math.abs(i)===1/0&&(i=0),i>=t)return-1;for(o=Math.max(i>=0?i:t-Math.abs(i),0);o<t;){if(o in r&&r[o]===e)return o;o++}return-1});